/**
 * Copyright (c) ELAXY Financial Software & Solutions GmbH & Co. KG Alle Rechte
 * vorbehalten.
 */
package test.orderproblem;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.hibernate.annotations.BatchSize;

/**
 * Person class.
 *
 */
@Entity
@Access(AccessType.FIELD)
@Table(name = "PERSON")
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name = "CLASSINDICATOR", discriminatorType = DiscriminatorType.INTEGER)
@DiscriminatorValue("1")
public class Person
{
  @Id
  @Column(name = "ID", nullable = false)
  @SequenceGenerator(name = "ID", sequenceName = "PERSON_SEQ")
  @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "ID")
  private Long id;

  @OneToMany(orphanRemoval = true, cascade = {CascadeType.PERSIST,
                                              CascadeType.REMOVE})
  @JoinColumn(name = "PERSONID", referencedColumnName = "ID", nullable = false, updatable = false)
  @BatchSize(size = 100)
  private Set<Address> addresses = new HashSet<Address>();

  public void addAddress(Address address)
  {
    this.addresses.add(address);
  }

}
